<?php

namespace smusatov\bzb2u\Render\Text;

class Line
{
    protected string $text;
    protected int $width;
    protected int $height;
    protected \ImagickDraw $draw;

    public function __construct(string $text)
    {
        if(empty(trim($text))) {
            throw new \Exception('Text in line not be empty');
        }

        $this->text = $text;

        $this->draw = new \ImagickDraw();
        $this->draw->setGravity(\Imagick::GRAVITY_CENTER);
        $this->draw->setStrokeAntialias(false);
        $this->draw->setTextAntialias(false);
        $this->draw->setFillColor(new \ImagickPixel('#000000'));
        $this->draw->setTextUnderColor(new \ImagickPixel('#ffffff'));

        $this->setFontRegular();
    }

    public function setFontBold()
    {
        $this->draw->setFont(__DIR__ . '/../../../font/Bold.ttf');
    }

    public function setFontRegular()
    {
        $this->draw->setFont(__DIR__ . '/../../../font/Regular.ttf');
    }

    public function setFontThin()
    {
        $this->draw->setFont(__DIR__ . '/../../../font/Thin.ttf');
    }

    public function setSize(int $width, int $height)
    {
        $this->width = $width;
        $this->height = $height;
    }

    public function render(): \Imagick
    {
        $im = new \Imagick();
        $im->setGravity(\Imagick::GRAVITY_CENTER);
        $im->setType(\Imagick::IMGTYPE_BILEVEL);
        $im->setAntiAlias(false);
        $im->setFormat('png');
        $im->setCompression(\Imagick::COMPRESSION_NO);
        $im->setBackgroundColor(new \ImagickPixel('#ffffff'));

        $fontSize = 7;
        do {
            $fontSize++;
            $this->draw->setFontSize($fontSize);
            $metrics = $im->queryFontMetrics($this->draw, $this->text);

        } while($metrics['textWidth'] <= $this->width && $metrics['textHeight'] <= $this->height);
        $this->draw->setFontSize($fontSize - 1);
        $metrics = $im->queryFontMetrics($this->draw, $this->text);
        print_r($metrics);

        $im->newImage($this->width, $this->height, new \ImagickPixel('#ffffff'), 'png');
        $im->setImageGravity(\Imagick::GRAVITY_CENTER);
        $im->annotateImage($this->draw, 0, 0, 0, $this->text);
        $y = floor($this->height * 0.07291667);
        $im->cropImage($this->width, $this->height - $y, 0, $y);

        return $im;
    }
}
